﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using OA.SL.RIA.StoredProc.Web;

namespace OA.SL.RIA.StoredProc
{
    public partial class MainPage : UserControl
    {
        DomainService1 service = new DomainService1();
        public MainPage()
        {
            InitializeComponent();
            this.OnStart();
        }

        /// <summary>
        /// Populate the listbox after the application starts
        /// </summary>
        private void OnStart()
        {
            var loadOperation = this.service.Load(this.service.GetCarsFromStoredProcedureQuery());
            this.ListCarStoredProcedureOnStart.ItemsSource = loadOperation.Entities;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            //Get from Stored Procedure as new Complex Type - CarInfo
            var carMakeModel = service.GetCarMakeModel();
            carMakeModel.Completed += (object s, EventArgs ev) =>
            {
                var carMakeModelAsString = carMakeModel.Value.Select(c => c.Make + " " + c.Model);

                ListCarMakeModel.ItemsSource = carMakeModelAsString;
            };

            //Get from Stored Procedure as Persistent Type - Car
            var cars = service.Load<Car>(service.GetCarsFromStoredProcedureQuery());
            cars.Completed += (object s, EventArgs ev) =>
            {
                var carAll = cars.Entities.Select(c => c.Make + " " + c.Model);

                ListCarStoredProcedure.ItemsSource = carAll;
            };
        }
    }
}
